#
# Sonar, open source software quality management tool.
# Copyright (C) 2009 SonarSource SA
# mailto:contact AT sonarsource DOT com
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Sonar; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
class Api::ServerController < Api::RestController

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :consolidate_snapshot ]

  def key
    id = Java::OrgSonarCore::Application.getInstance().getContainer().getComponent(Java::OrgSonarCore::ServerId.java_class).toString()
    render :text => id
  end

  def version
    render :text => Java::OrgSonarCore::Version.getVersion()
  end

  def consolidate_snapshot
    snapshot_id = params[:id]
    snapshot = Snapshot.find(snapshot_id, :conditions => {:status => Snapshot::STATUS_UNPROCESSED, :scope => Project::SCOPE_PROJECT}) if snapshot_id

    if snapshot_id && snapshot
      Java::OrgSonarCore::Application.getInstance().getContainer().getComponent(Java::OrgSonarCoreBatch::Batch.java_class).process(snapshot_id.to_i)
      render :text => "Ok", :status => 200
    else
      render :text => "No snapshot id provided", :status => 400
    end
  end

end
