 #
 # Sonar, entreprise quality control tool.
 # Copyright (C) 2007-2008 Hortis-GRC SA
 # mailto:be_agile HAT hortis DOT ch
 #
 # Sonar is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 3 of the License, or (at your option) any later version.
 #
 # Sonar is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with Sonar; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 #
module ProjectHelper
  include ActionView::Helpers::UrlHelper

  def item_by_metric_id(items, metric_id)
    return nil if items.nil?
    items.each do |item|
      return item if(item.metric.id==metric_id and item.rules_category_id.nil?)
    end
    nil
  end
  
  def item_by_metric_name_and_categ_id(items, metric_name, rules_category_id)
    return nil if items.nil?
    items.each do |item|
      return item if (item.metric.name==metric_name and 
                      item.rules_category_id == rules_category_id and 
                      item.rule_id.nil?)
    end
    nil
  end  

  def monitored_to_sentence(monitored_list)
    monitored_list.collect {|s|
        name = s.getName()
        time = time_ago_in_words(Time.at(s.getTime()/1000))
        "<b>#{name}</b> (for #{time})"
      }.to_sentence
  end
  
  def chart_complexity_data(snapshot, type)
    measure = snapshot.measure(Metric::CC_CLASSES_COUNT_DISTRIB)
    chart_complexity_data = ''
    if measure and measure.text_value
      parts = measure.text_value.split(';')
      parts.each do |part|
        if not chart_complexity_data.empty?
          chart_complexity_data << ','
        end
        if type == 'values'
          chart_complexity_data << part.split('=')[1].to_s
        elsif type == 'categories'
          chart_complexity_data << part.split('=')[0].to_s + '%2b'
        end 
      end
    end
    chart_complexity_data    
  end

  

  def formatted_value(measure, default='')
    measure ? measure.formatted_value : default
  end
    
end