#
# Sonar, entreprise quality control tool.
# Copyright (C) 2007-2008 Hortis-GRC SA
# mailto:be_agile HAT hortis DOT ch
#
# Sonar is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.
#
# Sonar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with {library}; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
#
class MeasureParameter < ActiveRecord::Base
  
  KEY_ALERT_LABEL = 'alert_label'
  
  belongs_to :project_measure, :foreign_key => 'measure_id'

  def to_hash_json(options={})
    hash = {'key' => param_key}
    hash['data'] = lob_value if lob_value
    hash['text_value'] = text_value if text_value
    hash['value'] = value if value
    hash
  end
  
  def to_xml(options={})
    xml = Builder::XmlMarkup.new
    xml.param do
      xml.key(param_key)
      xml.data {xml.cdata!(lob_value)} if lob_value
      xml.text_value {xml.cdata!(text_value)} if text_value
      xml.value(value) if value
    end
  end

end
