 #
 # Sonar, entreprise quality control tool.
 # Copyright (C) 2007-2008 Hortis-GRC SA
 # mailto:be_agile HAT hortis DOT ch
 #
 # Sonar is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 3 of the License, or (at your option) any later version.
 #
 # Sonar is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with Sonar; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 #


# DEPRECATED - use profile.rb instead
class RulesProfile < ActiveRecord::Base
  has_many :active_rules, :class_name => 'ActiveRule', :foreign_key => 'profile_id',
      :dependent => :destroy, :include => ['rule']
      
  has_many :alerts, :class_name => 'Alert', :foreign_key => 'profile_id',
        :dependent => :destroy

  has_many :active_rules_with_params, :class_name => 'ActiveRule', :foreign_key => 'profile_id',
      :include => ['active_rule_parameters']

  validates_uniqueness_of :name, :scope => :language, :case_sensitive => false
  validates_presence_of :name
  validates_exclusion_of :name, :in => %w( active ), :message => "reserved"

  DEFAULT_PROFILE_NAME = 'Sun checks'
  
  def self.find_by_name_and_language(name, language)
    RulesProfile.find(:first, :conditions => {:name => name, :language => language})
  end
  
  def self.find_active_profile_by_language(language)
    RulesProfile.find(:first, :conditions => {:default_profile => true, :language => language})
  end

  def active?
    active
  end
  
  def provided?
    provided
  end

  def active_rules_by_category_and_level(categ_id=nil, level=nil)
    result=[]
    active_rules.each do |active_rule|
      if categ_id.nil?
        result<<active_rule if active_rule.level==level or level.nil?
      elsif level.nil?
        result<<active_rule if active_rule.rule.rules_category_id==categ_id
      else
        result<<active_rule if active_rule.level==level and active_rule.rule.rules_category_id==categ_id
      end
    end
    result
  end

  def active_by_rule_id(rule_id)
    active_hash_by_rule_id[rule_id]
  end

  def self.options_for_select
    array=[]
    RulesProfile.find(:all, :order => 'name').each do |profile|
      label = profile.name
      label = label + ' (active)' if profile.default_profile?
      array<<[label, profile.id]
    end
    array
  end
  
  def unique_key
    name + "_" + language
  end
  
#  protected

  @active_hash_by_rule_id=nil
  def active_hash_by_rule_id
    if @active_hash_by_rule_id.nil?
      @active_hash_by_rule_id={}
      active_rules_with_params.each do |active_rule|
        @active_hash_by_rule_id[active_rule.rule_id]=active_rule
      end
    end
    @active_hash_by_rule_id
  end
end