 #
 # Sonar, entreprise quality control tool.
 # Copyright (C) 2007-2008 Hortis-GRC SA
 # mailto:be_agile HAT hortis DOT ch
 #
 # Sonar is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Lesser General Public
 # License as published by the Free Software Foundation; either
 # version 3 of the License, or (at your option) any later version.
 #
 # Sonar is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Lesser General Public License for more details.
 #
 # You should have received a copy of the GNU Lesser General Public
 # License along with Sonar; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 #
class Sonar::TimemachineRow
  attr_accessor :metric

  def initialize(metric)
    @metric=metric
    @measure_by_sid={}
  end

  def add_measure(measure)
    @measure_by_sid[measure.snapshot_id]=measure
  end

  def measure(snapshot)
    @measure_by_sid[snapshot.id]
  end

  def domain
    @metric.domain
  end

  def best_snapshot_id
    if metric.qualitative? and @measure_by_sid.lenght>0 and metric.direction!=0
      #todo
      nil
    else
      nil
    end
  end

  def <=>(other)
    (self.domain <=> other.domain).nonzero? || (self.metric.description <=> other.metric.description)
  end

  def sparkline_url
    if metric.numeric? and @measure_by_sid.size>1
      values=[]
      @measure_by_sid.values.each do |measure|
        values<<measure.snapshot.created_at.to_f
        if measure.value.nil?
          values<<0
        else
          values<<measure.value
        end
      end
      "/chart?cht=sl&chdi=80x15&chv=" + values*',' + '&.png'
     else
       nil
     end
  end
end
